package kr.co.icontrols.ilp300_700.admin.setting;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.global.Configure;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValKey;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.Configure.DefaultConfigValue;
import kr.co.icontrols.ilp300_700.global.Configure.SetValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.Declare.TargetPort;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Setting_MainServerType extends WpadScreen {

    String TAG = "AdminSet_Setting_MainServerType";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    String strText_Title = "단지관리 시스템";
    String strText_Line_01_Item = "1] 단지서버 1.0 (분리)";
    String strText_Line_02_Item = "2] 단지서버 1.5 (통합)";
    String strText_Line_03_Item = "3] 단지서버 2.0";
    String strText_Line_04_Item = "4] 단지서버 1.0/2.0 Mixed";
    public AdminSet_Setting_MainServerType(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Setting_MainServerType] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_04_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item);
            ViewRegistration(layout, Text_Line_04_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item).Y);
            Text_Line_04_Item.setText(strText_Line_04_Item);

            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Setting_MainServerType(...) : " + e);
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] ===== START =====");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize() : " + e);
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Setting_MainServerType] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(...) : " + e);
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
//            LOG("[onKeyDown] keyCode [" + keyCode + "], event [" + event + "]");
            if (keyCode == Declare.Button.NUMBER_01) {
                // 분리형 서버
                if (setMainServerType(SetValue.Server_Separated)) {
                    MainActivity.mIOInterface.setDns(DefaultConfigValue.strDNSIPAddress, Declare.Const.DNS_IP2);
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    super.setChangeScreen(ID.SCREENS.Reboot);
                    //super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_02) {
                // 통합형 서버
                if (setMainServerType(SetValue.Server_Integrated)) {
                    MainActivity.mIOInterface.setDns(DefaultConfigValue.strDNSIPAddress, Declare.Const.DNS_IP2);
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    super.setChangeScreen(ID.SCREENS.Reboot);
                    //super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_03) {
                // 단지서버 2.0
                if (setMainServerType(SetValue.Server2dot0_Integrated)) {
                    MainActivity.mIOInterface.setDns(DefaultConfigValue.strDNSIPAddress, Declare.Const.DNS_IP2);
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    super.setChangeScreen(ID.SCREENS.Reboot);
                    //super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.NUMBER_04) {

                // 단지서버 1.0/2.0 Mixed
                if (setMainServerType(SetValue.ServerMixed_Integrated)) {
                    MainActivity.mIOInterface.setDns(DefaultConfigValue.strDNS2IPAddress, Declare.Const.DNS_IP2);
                    MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                    super.setChangeScreen(ID.SCREENS.Reboot);
                    //super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else {
                    MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                }
            } else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(...) : " + e);
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    public POSITION getPosition(int nID) {
//        LOG("[getPosition] Start!!");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(30, 84, 420, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(30, 134, 420, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(30, 184, 420, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_MAINSERVERTYPE.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(30, 234, 420, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition(int nID)");
            e.printStackTrace();
            return position;
        }
    }

    private boolean setMainServerType(SetValue eSetValue) {
        try {
            LOG("[setMainServerType] eSetValue [" + eSetValue + "]");
            boolean biMAPServerRestart = false;

            if (eSetValue == SetValue.Server_Separated) {
                if (ConfigValue.eMainServerType == SetValue.Server2dot0_Integrated)
                    biMAPServerRestart = true;

                ConfigValue.eMainServerType = SetValue.Server_Separated;
                ConfigValue.eSubServerType = SetValue.Server_Separated;
                ConfigValue.strMainServerIPAddress = DefaultConfigValue.strMainServerIPAddress;
                ConfigValue.strMonitoringPCIPAddress = DefaultConfigValue.strMonitoringPCIPAddress;
                ConfigValue.strDNSIPAddress = DefaultConfigValue.strDNSIPAddress;
                ConfigValue.nMainServerPortNum = TargetPort.nServer1_X;
            } else if (eSetValue == SetValue.Server_Integrated) {
                if (ConfigValue.eMainServerType == SetValue.Server2dot0_Integrated)
                    biMAPServerRestart = true;

                ConfigValue.eMainServerType = SetValue.Server_Integrated;
                ConfigValue.eSubServerType = SetValue.Server_Integrated;
                ConfigValue.strMonitoringPCIPAddress = DefaultConfigValue.strMainServerIPAddress;
                ConfigValue.strDNSIPAddress = DefaultConfigValue.strDNSIPAddress;
                ConfigValue.nMainServerPortNum = TargetPort.nServer1_X;
            } else if (eSetValue == SetValue.Server2dot0_Integrated) {
                if ((ConfigValue.eMainServerType != SetValue.Server2dot0_Integrated)||(ConfigValue.eSubServerType != SetValue.Server2dot0_Integrated))
                    biMAPServerRestart = true;

                ConfigValue.eMainServerType = SetValue.Server2dot0_Integrated;
                ConfigValue.eSubServerType = SetValue.Server2dot0_Integrated;
                ConfigValue.strMainServerIPAddress = DefaultConfigValue.strMainServerIPAddress;
                ConfigValue.strMonitoringPCIPAddress = DefaultConfigValue.strMainServerIPAddress;
                ConfigValue.strDNSIPAddress = DefaultConfigValue.strDNSIPAddress;
                ConfigValue.nMainServerPortNum = TargetPort.nServer2_0;
            } else if (eSetValue == SetValue.ServerMixed_Integrated) {
                if (ConfigValue.eSubServerType != SetValue.ServerMixed_Integrated)
                    biMAPServerRestart = true;

                ConfigValue.eMainServerType = SetValue.Server2dot0_Integrated;
                //ConfigValue.eMainServerType = SetValue.ServerMixed_Integrated;
                ConfigValue.eSubServerType = SetValue.ServerMixed_Integrated;
                ConfigValue.strMonitoringPCIPAddress = DefaultConfigValue.strMainServer2IPAddress;
                ConfigValue.strMainServerIPAddress = DefaultConfigValue.strMainServer2IPAddress;
                ConfigValue.strDNSIPAddress = DefaultConfigValue.strDNS2IPAddress;
                ConfigValue.nMainServerPortNum = TargetPort.nServer2_0;
                ConfigValue.nSubServerPortNum = TargetPort.nServer1_X;
            } else {
                Log.w(TAG, "[setMainServerType] eSetValue is not available!!");
                return false;
            }

            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.MainServerType, ConfigValue.eMainServerType))
                return false;
            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.SubServerType, ConfigValue.eSubServerType))
                return false;
            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.MonitoringPCIPAddress, ConfigValue.strMonitoringPCIPAddress))
                return false;
            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.MainServerIPAddress, ConfigValue.strMainServerIPAddress))
                return false;
            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.DNSIPAddress, ConfigValue.strDNSIPAddress))
                return false;
            if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.MainServerPortNum, ConfigValue.nMainServerPortNum))
                return false;

            Log.i(TAG, "[setMainServerType] biMAPServerRestart [" + biMAPServerRestart + "], ConfigValue.eMainServerType [" + ConfigValue.eMainServerType + "]");
            Log.i(TAG, "[setMainServerType] ConfigValue.strMonitoringPCIPAddress [" + ConfigValue.strMonitoringPCIPAddress + "], ConfigValue.nMainServerPortNum [" + ConfigValue.nMainServerPortNum + "]");

            if (biMAPServerRestart) ((MainActivity) mContext).restartiMAPServer();

            ((MainActivity) mContext).sendHandlerMsgDelayed(MainActivity.HANDLERMSG.SEND_HEARTBEAT_NOTICE, 0, 0, 2000);

            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setMainServerType(SetValue eSetValue)");
            e.printStackTrace();
            return false;
        }
    }


}